// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robomaker_simulation_msgs:msg/Tag.idl
// generated code does not contain a copyright notice

#ifndef ROBOMAKER_SIMULATION_MSGS__MSG__TAG__STRUCT_HPP_
#define ROBOMAKER_SIMULATION_MSGS__MSG__TAG__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__robomaker_simulation_msgs__msg__Tag __attribute__((deprecated))
#else
# define DEPRECATED__robomaker_simulation_msgs__msg__Tag __declspec(deprecated)
#endif

namespace robomaker_simulation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Tag_
{
  using Type = Tag_<ContainerAllocator>;

  explicit Tag_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->key = "";
      this->value = "";
    }
  }

  explicit Tag_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : key(_alloc),
    value(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->key = "";
      this->value = "";
    }
  }

  // field types and members
  using _key_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _key_type key;
  using _value_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _value_type value;

  // setters for named parameter idiom
  Type & set__key(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->key = _arg;
    return *this;
  }
  Type & set__value(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robomaker_simulation_msgs::msg::Tag_<ContainerAllocator> *;
  using ConstRawPtr =
    const robomaker_simulation_msgs::msg::Tag_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robomaker_simulation_msgs__msg__Tag
    std::shared_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robomaker_simulation_msgs__msg__Tag
    std::shared_ptr<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Tag_ & other) const
  {
    if (this->key != other.key) {
      return false;
    }
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const Tag_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Tag_

// alias to use template instance with default allocator
using Tag =
  robomaker_simulation_msgs::msg::Tag_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace robomaker_simulation_msgs

#endif  // ROBOMAKER_SIMULATION_MSGS__MSG__TAG__STRUCT_HPP_
