// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robomaker_simulation_msgs:srv/AddTags.idl
// generated code does not contain a copyright notice

#ifndef ROBOMAKER_SIMULATION_MSGS__SRV__ADD_TAGS__STRUCT_HPP_
#define ROBOMAKER_SIMULATION_MSGS__SRV__ADD_TAGS__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

// Include directives for member types
// Member 'tags'
#include "robomaker_simulation_msgs/msg/tag__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Request __attribute__((deprecated))
#else
# define DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Request __declspec(deprecated)
#endif

namespace robomaker_simulation_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AddTags_Request_
{
  using Type = AddTags_Request_<ContainerAllocator>;

  explicit AddTags_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit AddTags_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _tags_type =
    std::vector<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>, typename ContainerAllocator::template rebind<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>>::other>;
  _tags_type tags;

  // setters for named parameter idiom
  Type & set__tags(
    const std::vector<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>, typename ContainerAllocator::template rebind<robomaker_simulation_msgs::msg::Tag_<ContainerAllocator>>::other> & _arg)
  {
    this->tags = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Request
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Request
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AddTags_Request_ & other) const
  {
    if (this->tags != other.tags) {
      return false;
    }
    return true;
  }
  bool operator!=(const AddTags_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AddTags_Request_

// alias to use template instance with default allocator
using AddTags_Request =
  robomaker_simulation_msgs::srv::AddTags_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace robomaker_simulation_msgs

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Response __attribute__((deprecated))
#else
# define DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Response __declspec(deprecated)
#endif

namespace robomaker_simulation_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct AddTags_Response_
{
  using Type = AddTags_Response_<ContainerAllocator>;

  explicit AddTags_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  explicit AddTags_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->message = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Response
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robomaker_simulation_msgs__srv__AddTags_Response
    std::shared_ptr<robomaker_simulation_msgs::srv::AddTags_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AddTags_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const AddTags_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AddTags_Response_

// alias to use template instance with default allocator
using AddTags_Response =
  robomaker_simulation_msgs::srv::AddTags_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace robomaker_simulation_msgs

namespace robomaker_simulation_msgs
{

namespace srv
{

struct AddTags
{
  using Request = robomaker_simulation_msgs::srv::AddTags_Request;
  using Response = robomaker_simulation_msgs::srv::AddTags_Response;
};

}  // namespace srv

}  // namespace robomaker_simulation_msgs

#endif  // ROBOMAKER_SIMULATION_MSGS__SRV__ADD_TAGS__STRUCT_HPP_
