#ifndef _H_CB48E7A688766C80E25802CADC5F91E3_AddTags__H_
#define _H_CB48E7A688766C80E25802CADC5F91E3_AddTags__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "robomaker_simulation_msgs/msg/dds_opensplice/Tag_.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  AddTags_Request_
            {
                struct _tags__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::robomaker_simulation_msgs::msg::dds_::Tag_, struct _tags__seq_uniq_ > _tags__seq;
                typedef DDS_DCPSSequence_var< _tags__seq > _tags__seq_var;
                typedef DDS_DCPSSequence_out< _tags__seq > _tags__seq_out;
                _tags__seq tags_;
            };

            typedef DDS_DCPSStruct_var<AddTags_Request_> AddTags_Request__var;
            typedef DDS_DCPSStruct_out < AddTags_Request_> AddTags_Request__out;

            struct  AddTags_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<AddTags_Response_> AddTags_Response__var;
            typedef DDS_DCPSStruct_out < AddTags_Response_> AddTags_Response__out;

            struct  Sample_AddTags_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::AddTags_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddTags_Request_> Sample_AddTags_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AddTags_Request_> Sample_AddTags_Request__out;

            struct  Sample_AddTags_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::AddTags_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AddTags_Response_> Sample_AddTags_Response__var;
            typedef DDS_DCPSStruct_out < Sample_AddTags_Response_> Sample_AddTags_Response__out;

        }

    }

}

#endif /* _H_CB48E7A688766C80E25802CADC5F91E3_AddTags__H_ */
