#ifndef _H_CB48E7A688766C80E25802CADC5F91E3_AddTags_DCPS_H_
#define _H_CB48E7A688766C80E25802CADC5F91E3_AddTags_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AddTags_.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class AddTags_Request_TypeSupportInterface;

            typedef AddTags_Request_TypeSupportInterface * AddTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Request_TypeSupportInterface> AddTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddTags_Request_TypeSupportInterface> AddTags_Request_TypeSupportInterface_out;


            class AddTags_Request_DataWriter;

            typedef AddTags_Request_DataWriter * AddTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Request_DataWriter> AddTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddTags_Request_DataWriter> AddTags_Request_DataWriter_out;


            class AddTags_Request_DataReader;

            typedef AddTags_Request_DataReader * AddTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Request_DataReader> AddTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AddTags_Request_DataReader> AddTags_Request_DataReader_out;


            class AddTags_Request_DataReaderView;

            typedef AddTags_Request_DataReaderView * AddTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Request_DataReaderView> AddTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddTags_Request_DataReaderView> AddTags_Request_DataReaderView_out;

            struct AddTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddTags_Request_, struct AddTags_Request_Seq_uniq_> AddTags_Request_Seq;
            typedef DDS_DCPSSequence_var < AddTags_Request_Seq> AddTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AddTags_Request_Seq> AddTags_Request_Seq_out;

            class  AddTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AddTags_Request_TypeSupportInterface_var _var_type;

                static AddTags_Request_TypeSupportInterface_ptr _duplicate (AddTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddTags_Request_TypeSupportInterface () {};
                ~AddTags_Request_TypeSupportInterface () {};
            private:
                AddTags_Request_TypeSupportInterface (const AddTags_Request_TypeSupportInterface &);
                AddTags_Request_TypeSupportInterface & operator = (const AddTags_Request_TypeSupportInterface &);
            };

            class  AddTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddTags_Request_DataWriter_ptr _ptr_type;
                typedef AddTags_Request_DataWriter_var _var_type;

                static AddTags_Request_DataWriter_ptr _duplicate (AddTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddTags_Request_& instance_data) = 0;

            protected:
                AddTags_Request_DataWriter () {};
                ~AddTags_Request_DataWriter () {};
            private:
                AddTags_Request_DataWriter (const AddTags_Request_DataWriter &);
                AddTags_Request_DataWriter & operator = (const AddTags_Request_DataWriter &);
            };

            class  AddTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddTags_Request_DataReader_ptr _ptr_type;
                typedef AddTags_Request_DataReader_var _var_type;

                static AddTags_Request_DataReader_ptr _duplicate (AddTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddTags_Request_& instance) = 0;

            protected:
                AddTags_Request_DataReader () {};
                ~AddTags_Request_DataReader () {};
            private:
                AddTags_Request_DataReader (const AddTags_Request_DataReader &);
                AddTags_Request_DataReader & operator = (const AddTags_Request_DataReader &);
            };

            class  AddTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddTags_Request_DataReaderView_ptr _ptr_type;
                typedef AddTags_Request_DataReaderView_var _var_type;

                static AddTags_Request_DataReaderView_ptr _duplicate (AddTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddTags_Request_& instance) = 0;

            protected:
                AddTags_Request_DataReaderView () {};
                ~AddTags_Request_DataReaderView () {};
            private:
                AddTags_Request_DataReaderView (const AddTags_Request_DataReaderView &);
                AddTags_Request_DataReaderView & operator = (const AddTags_Request_DataReaderView &);
            };
            class AddTags_Response_TypeSupportInterface;

            typedef AddTags_Response_TypeSupportInterface * AddTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Response_TypeSupportInterface> AddTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AddTags_Response_TypeSupportInterface> AddTags_Response_TypeSupportInterface_out;


            class AddTags_Response_DataWriter;

            typedef AddTags_Response_DataWriter * AddTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Response_DataWriter> AddTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AddTags_Response_DataWriter> AddTags_Response_DataWriter_out;


            class AddTags_Response_DataReader;

            typedef AddTags_Response_DataReader * AddTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Response_DataReader> AddTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AddTags_Response_DataReader> AddTags_Response_DataReader_out;


            class AddTags_Response_DataReaderView;

            typedef AddTags_Response_DataReaderView * AddTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AddTags_Response_DataReaderView> AddTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AddTags_Response_DataReaderView> AddTags_Response_DataReaderView_out;

            struct AddTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AddTags_Response_, struct AddTags_Response_Seq_uniq_> AddTags_Response_Seq;
            typedef DDS_DCPSSequence_var < AddTags_Response_Seq> AddTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AddTags_Response_Seq> AddTags_Response_Seq_out;

            class  AddTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AddTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AddTags_Response_TypeSupportInterface_var _var_type;

                static AddTags_Response_TypeSupportInterface_ptr _duplicate (AddTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AddTags_Response_TypeSupportInterface () {};
                ~AddTags_Response_TypeSupportInterface () {};
            private:
                AddTags_Response_TypeSupportInterface (const AddTags_Response_TypeSupportInterface &);
                AddTags_Response_TypeSupportInterface & operator = (const AddTags_Response_TypeSupportInterface &);
            };

            class  AddTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AddTags_Response_DataWriter_ptr _ptr_type;
                typedef AddTags_Response_DataWriter_var _var_type;

                static AddTags_Response_DataWriter_ptr _duplicate (AddTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AddTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AddTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AddTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddTags_Response_& instance_data) = 0;

            protected:
                AddTags_Response_DataWriter () {};
                ~AddTags_Response_DataWriter () {};
            private:
                AddTags_Response_DataWriter (const AddTags_Response_DataWriter &);
                AddTags_Response_DataWriter & operator = (const AddTags_Response_DataWriter &);
            };

            class  AddTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AddTags_Response_DataReader_ptr _ptr_type;
                typedef AddTags_Response_DataReader_var _var_type;

                static AddTags_Response_DataReader_ptr _duplicate (AddTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddTags_Response_& instance) = 0;

            protected:
                AddTags_Response_DataReader () {};
                ~AddTags_Response_DataReader () {};
            private:
                AddTags_Response_DataReader (const AddTags_Response_DataReader &);
                AddTags_Response_DataReader & operator = (const AddTags_Response_DataReader &);
            };

            class  AddTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AddTags_Response_DataReaderView_ptr _ptr_type;
                typedef AddTags_Response_DataReaderView_var _var_type;

                static AddTags_Response_DataReaderView_ptr _duplicate (AddTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AddTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AddTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AddTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AddTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AddTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AddTags_Response_& instance) = 0;

            protected:
                AddTags_Response_DataReaderView () {};
                ~AddTags_Response_DataReaderView () {};
            private:
                AddTags_Response_DataReaderView (const AddTags_Response_DataReaderView &);
                AddTags_Response_DataReaderView & operator = (const AddTags_Response_DataReaderView &);
            };
            class Sample_AddTags_Request_TypeSupportInterface;

            typedef Sample_AddTags_Request_TypeSupportInterface * Sample_AddTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Request_TypeSupportInterface> Sample_AddTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Request_TypeSupportInterface> Sample_AddTags_Request_TypeSupportInterface_out;


            class Sample_AddTags_Request_DataWriter;

            typedef Sample_AddTags_Request_DataWriter * Sample_AddTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Request_DataWriter> Sample_AddTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Request_DataWriter> Sample_AddTags_Request_DataWriter_out;


            class Sample_AddTags_Request_DataReader;

            typedef Sample_AddTags_Request_DataReader * Sample_AddTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Request_DataReader> Sample_AddTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Request_DataReader> Sample_AddTags_Request_DataReader_out;


            class Sample_AddTags_Request_DataReaderView;

            typedef Sample_AddTags_Request_DataReaderView * Sample_AddTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Request_DataReaderView> Sample_AddTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Request_DataReaderView> Sample_AddTags_Request_DataReaderView_out;

            struct Sample_AddTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddTags_Request_, struct Sample_AddTags_Request_Seq_uniq_> Sample_AddTags_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddTags_Request_Seq> Sample_AddTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddTags_Request_Seq> Sample_AddTags_Request_Seq_out;

            class  Sample_AddTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddTags_Request_TypeSupportInterface_var _var_type;

                static Sample_AddTags_Request_TypeSupportInterface_ptr _duplicate (Sample_AddTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddTags_Request_TypeSupportInterface () {};
                ~Sample_AddTags_Request_TypeSupportInterface () {};
            private:
                Sample_AddTags_Request_TypeSupportInterface (const Sample_AddTags_Request_TypeSupportInterface &);
                Sample_AddTags_Request_TypeSupportInterface & operator = (const Sample_AddTags_Request_TypeSupportInterface &);
            };

            class  Sample_AddTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddTags_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AddTags_Request_DataWriter_var _var_type;

                static Sample_AddTags_Request_DataWriter_ptr _duplicate (Sample_AddTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddTags_Request_& instance_data) = 0;

            protected:
                Sample_AddTags_Request_DataWriter () {};
                ~Sample_AddTags_Request_DataWriter () {};
            private:
                Sample_AddTags_Request_DataWriter (const Sample_AddTags_Request_DataWriter &);
                Sample_AddTags_Request_DataWriter & operator = (const Sample_AddTags_Request_DataWriter &);
            };

            class  Sample_AddTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddTags_Request_DataReader_ptr _ptr_type;
                typedef Sample_AddTags_Request_DataReader_var _var_type;

                static Sample_AddTags_Request_DataReader_ptr _duplicate (Sample_AddTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddTags_Request_& instance) = 0;

            protected:
                Sample_AddTags_Request_DataReader () {};
                ~Sample_AddTags_Request_DataReader () {};
            private:
                Sample_AddTags_Request_DataReader (const Sample_AddTags_Request_DataReader &);
                Sample_AddTags_Request_DataReader & operator = (const Sample_AddTags_Request_DataReader &);
            };

            class  Sample_AddTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddTags_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AddTags_Request_DataReaderView_var _var_type;

                static Sample_AddTags_Request_DataReaderView_ptr _duplicate (Sample_AddTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddTags_Request_& instance) = 0;

            protected:
                Sample_AddTags_Request_DataReaderView () {};
                ~Sample_AddTags_Request_DataReaderView () {};
            private:
                Sample_AddTags_Request_DataReaderView (const Sample_AddTags_Request_DataReaderView &);
                Sample_AddTags_Request_DataReaderView & operator = (const Sample_AddTags_Request_DataReaderView &);
            };
            class Sample_AddTags_Response_TypeSupportInterface;

            typedef Sample_AddTags_Response_TypeSupportInterface * Sample_AddTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Response_TypeSupportInterface> Sample_AddTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Response_TypeSupportInterface> Sample_AddTags_Response_TypeSupportInterface_out;


            class Sample_AddTags_Response_DataWriter;

            typedef Sample_AddTags_Response_DataWriter * Sample_AddTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Response_DataWriter> Sample_AddTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Response_DataWriter> Sample_AddTags_Response_DataWriter_out;


            class Sample_AddTags_Response_DataReader;

            typedef Sample_AddTags_Response_DataReader * Sample_AddTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Response_DataReader> Sample_AddTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Response_DataReader> Sample_AddTags_Response_DataReader_out;


            class Sample_AddTags_Response_DataReaderView;

            typedef Sample_AddTags_Response_DataReaderView * Sample_AddTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AddTags_Response_DataReaderView> Sample_AddTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AddTags_Response_DataReaderView> Sample_AddTags_Response_DataReaderView_out;

            struct Sample_AddTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AddTags_Response_, struct Sample_AddTags_Response_Seq_uniq_> Sample_AddTags_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AddTags_Response_Seq> Sample_AddTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AddTags_Response_Seq> Sample_AddTags_Response_Seq_out;

            class  Sample_AddTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AddTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AddTags_Response_TypeSupportInterface_var _var_type;

                static Sample_AddTags_Response_TypeSupportInterface_ptr _duplicate (Sample_AddTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AddTags_Response_TypeSupportInterface () {};
                ~Sample_AddTags_Response_TypeSupportInterface () {};
            private:
                Sample_AddTags_Response_TypeSupportInterface (const Sample_AddTags_Response_TypeSupportInterface &);
                Sample_AddTags_Response_TypeSupportInterface & operator = (const Sample_AddTags_Response_TypeSupportInterface &);
            };

            class  Sample_AddTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AddTags_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AddTags_Response_DataWriter_var _var_type;

                static Sample_AddTags_Response_DataWriter_ptr _duplicate (Sample_AddTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AddTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AddTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AddTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AddTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddTags_Response_& instance_data) = 0;

            protected:
                Sample_AddTags_Response_DataWriter () {};
                ~Sample_AddTags_Response_DataWriter () {};
            private:
                Sample_AddTags_Response_DataWriter (const Sample_AddTags_Response_DataWriter &);
                Sample_AddTags_Response_DataWriter & operator = (const Sample_AddTags_Response_DataWriter &);
            };

            class  Sample_AddTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AddTags_Response_DataReader_ptr _ptr_type;
                typedef Sample_AddTags_Response_DataReader_var _var_type;

                static Sample_AddTags_Response_DataReader_ptr _duplicate (Sample_AddTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddTags_Response_& instance) = 0;

            protected:
                Sample_AddTags_Response_DataReader () {};
                ~Sample_AddTags_Response_DataReader () {};
            private:
                Sample_AddTags_Response_DataReader (const Sample_AddTags_Response_DataReader &);
                Sample_AddTags_Response_DataReader & operator = (const Sample_AddTags_Response_DataReader &);
            };

            class  Sample_AddTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AddTags_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AddTags_Response_DataReaderView_var _var_type;

                static Sample_AddTags_Response_DataReaderView_ptr _duplicate (Sample_AddTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AddTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AddTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AddTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AddTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AddTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AddTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AddTags_Response_& instance) = 0;

            protected:
                Sample_AddTags_Response_DataReaderView () {};
                ~Sample_AddTags_Response_DataReaderView () {};
            private:
                Sample_AddTags_Response_DataReaderView (const Sample_AddTags_Response_DataReaderView &);
                Sample_AddTags_Response_DataReaderView & operator = (const Sample_AddTags_Response_DataReaderView &);
            };
        }

    }

}

#endif
