#ifndef _H_258E781FEA53DC6D18CE1B6CC46E14AE_Cancel_DCPS_H_
#define _H_258E781FEA53DC6D18CE1B6CC46E14AE_Cancel_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Cancel_.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class Cancel_Request_TypeSupportInterface;

            typedef Cancel_Request_TypeSupportInterface * Cancel_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Request_TypeSupportInterface> Cancel_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Cancel_Request_TypeSupportInterface> Cancel_Request_TypeSupportInterface_out;


            class Cancel_Request_DataWriter;

            typedef Cancel_Request_DataWriter * Cancel_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Request_DataWriter> Cancel_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Cancel_Request_DataWriter> Cancel_Request_DataWriter_out;


            class Cancel_Request_DataReader;

            typedef Cancel_Request_DataReader * Cancel_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Request_DataReader> Cancel_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Cancel_Request_DataReader> Cancel_Request_DataReader_out;


            class Cancel_Request_DataReaderView;

            typedef Cancel_Request_DataReaderView * Cancel_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Request_DataReaderView> Cancel_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Cancel_Request_DataReaderView> Cancel_Request_DataReaderView_out;

            struct Cancel_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Cancel_Request_, struct Cancel_Request_Seq_uniq_> Cancel_Request_Seq;
            typedef DDS_DCPSSequence_var < Cancel_Request_Seq> Cancel_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Cancel_Request_Seq> Cancel_Request_Seq_out;

            class  Cancel_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Cancel_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Cancel_Request_TypeSupportInterface_var _var_type;

                static Cancel_Request_TypeSupportInterface_ptr _duplicate (Cancel_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Cancel_Request_TypeSupportInterface () {};
                ~Cancel_Request_TypeSupportInterface () {};
            private:
                Cancel_Request_TypeSupportInterface (const Cancel_Request_TypeSupportInterface &);
                Cancel_Request_TypeSupportInterface & operator = (const Cancel_Request_TypeSupportInterface &);
            };

            class  Cancel_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Cancel_Request_DataWriter_ptr _ptr_type;
                typedef Cancel_Request_DataWriter_var _var_type;

                static Cancel_Request_DataWriter_ptr _duplicate (Cancel_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Cancel_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Cancel_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Cancel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cancel_Request_& instance_data) = 0;

            protected:
                Cancel_Request_DataWriter () {};
                ~Cancel_Request_DataWriter () {};
            private:
                Cancel_Request_DataWriter (const Cancel_Request_DataWriter &);
                Cancel_Request_DataWriter & operator = (const Cancel_Request_DataWriter &);
            };

            class  Cancel_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Cancel_Request_DataReader_ptr _ptr_type;
                typedef Cancel_Request_DataReader_var _var_type;

                static Cancel_Request_DataReader_ptr _duplicate (Cancel_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Cancel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cancel_Request_& instance) = 0;

            protected:
                Cancel_Request_DataReader () {};
                ~Cancel_Request_DataReader () {};
            private:
                Cancel_Request_DataReader (const Cancel_Request_DataReader &);
                Cancel_Request_DataReader & operator = (const Cancel_Request_DataReader &);
            };

            class  Cancel_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Cancel_Request_DataReaderView_ptr _ptr_type;
                typedef Cancel_Request_DataReaderView_var _var_type;

                static Cancel_Request_DataReaderView_ptr _duplicate (Cancel_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Cancel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cancel_Request_& instance) = 0;

            protected:
                Cancel_Request_DataReaderView () {};
                ~Cancel_Request_DataReaderView () {};
            private:
                Cancel_Request_DataReaderView (const Cancel_Request_DataReaderView &);
                Cancel_Request_DataReaderView & operator = (const Cancel_Request_DataReaderView &);
            };
            class Cancel_Response_TypeSupportInterface;

            typedef Cancel_Response_TypeSupportInterface * Cancel_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Response_TypeSupportInterface> Cancel_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Cancel_Response_TypeSupportInterface> Cancel_Response_TypeSupportInterface_out;


            class Cancel_Response_DataWriter;

            typedef Cancel_Response_DataWriter * Cancel_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Response_DataWriter> Cancel_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Cancel_Response_DataWriter> Cancel_Response_DataWriter_out;


            class Cancel_Response_DataReader;

            typedef Cancel_Response_DataReader * Cancel_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Response_DataReader> Cancel_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Cancel_Response_DataReader> Cancel_Response_DataReader_out;


            class Cancel_Response_DataReaderView;

            typedef Cancel_Response_DataReaderView * Cancel_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Cancel_Response_DataReaderView> Cancel_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Cancel_Response_DataReaderView> Cancel_Response_DataReaderView_out;

            struct Cancel_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Cancel_Response_, struct Cancel_Response_Seq_uniq_> Cancel_Response_Seq;
            typedef DDS_DCPSSequence_var < Cancel_Response_Seq> Cancel_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Cancel_Response_Seq> Cancel_Response_Seq_out;

            class  Cancel_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Cancel_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Cancel_Response_TypeSupportInterface_var _var_type;

                static Cancel_Response_TypeSupportInterface_ptr _duplicate (Cancel_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Cancel_Response_TypeSupportInterface () {};
                ~Cancel_Response_TypeSupportInterface () {};
            private:
                Cancel_Response_TypeSupportInterface (const Cancel_Response_TypeSupportInterface &);
                Cancel_Response_TypeSupportInterface & operator = (const Cancel_Response_TypeSupportInterface &);
            };

            class  Cancel_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Cancel_Response_DataWriter_ptr _ptr_type;
                typedef Cancel_Response_DataWriter_var _var_type;

                static Cancel_Response_DataWriter_ptr _duplicate (Cancel_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Cancel_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Cancel_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Cancel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cancel_Response_& instance_data) = 0;

            protected:
                Cancel_Response_DataWriter () {};
                ~Cancel_Response_DataWriter () {};
            private:
                Cancel_Response_DataWriter (const Cancel_Response_DataWriter &);
                Cancel_Response_DataWriter & operator = (const Cancel_Response_DataWriter &);
            };

            class  Cancel_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Cancel_Response_DataReader_ptr _ptr_type;
                typedef Cancel_Response_DataReader_var _var_type;

                static Cancel_Response_DataReader_ptr _duplicate (Cancel_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Cancel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cancel_Response_& instance) = 0;

            protected:
                Cancel_Response_DataReader () {};
                ~Cancel_Response_DataReader () {};
            private:
                Cancel_Response_DataReader (const Cancel_Response_DataReader &);
                Cancel_Response_DataReader & operator = (const Cancel_Response_DataReader &);
            };

            class  Cancel_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Cancel_Response_DataReaderView_ptr _ptr_type;
                typedef Cancel_Response_DataReaderView_var _var_type;

                static Cancel_Response_DataReaderView_ptr _duplicate (Cancel_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Cancel_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Cancel_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Cancel_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Cancel_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Cancel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Cancel_Response_& instance) = 0;

            protected:
                Cancel_Response_DataReaderView () {};
                ~Cancel_Response_DataReaderView () {};
            private:
                Cancel_Response_DataReaderView (const Cancel_Response_DataReaderView &);
                Cancel_Response_DataReaderView & operator = (const Cancel_Response_DataReaderView &);
            };
            class Sample_Cancel_Request_TypeSupportInterface;

            typedef Sample_Cancel_Request_TypeSupportInterface * Sample_Cancel_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Request_TypeSupportInterface> Sample_Cancel_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Request_TypeSupportInterface> Sample_Cancel_Request_TypeSupportInterface_out;


            class Sample_Cancel_Request_DataWriter;

            typedef Sample_Cancel_Request_DataWriter * Sample_Cancel_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Request_DataWriter> Sample_Cancel_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Request_DataWriter> Sample_Cancel_Request_DataWriter_out;


            class Sample_Cancel_Request_DataReader;

            typedef Sample_Cancel_Request_DataReader * Sample_Cancel_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Request_DataReader> Sample_Cancel_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Request_DataReader> Sample_Cancel_Request_DataReader_out;


            class Sample_Cancel_Request_DataReaderView;

            typedef Sample_Cancel_Request_DataReaderView * Sample_Cancel_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Request_DataReaderView> Sample_Cancel_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Request_DataReaderView> Sample_Cancel_Request_DataReaderView_out;

            struct Sample_Cancel_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Cancel_Request_, struct Sample_Cancel_Request_Seq_uniq_> Sample_Cancel_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Cancel_Request_Seq> Sample_Cancel_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Cancel_Request_Seq> Sample_Cancel_Request_Seq_out;

            class  Sample_Cancel_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Cancel_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Cancel_Request_TypeSupportInterface_var _var_type;

                static Sample_Cancel_Request_TypeSupportInterface_ptr _duplicate (Sample_Cancel_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Cancel_Request_TypeSupportInterface () {};
                ~Sample_Cancel_Request_TypeSupportInterface () {};
            private:
                Sample_Cancel_Request_TypeSupportInterface (const Sample_Cancel_Request_TypeSupportInterface &);
                Sample_Cancel_Request_TypeSupportInterface & operator = (const Sample_Cancel_Request_TypeSupportInterface &);
            };

            class  Sample_Cancel_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Cancel_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Cancel_Request_DataWriter_var _var_type;

                static Sample_Cancel_Request_DataWriter_ptr _duplicate (Sample_Cancel_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Cancel_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Cancel_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Cancel_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Cancel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Cancel_Request_& instance_data) = 0;

            protected:
                Sample_Cancel_Request_DataWriter () {};
                ~Sample_Cancel_Request_DataWriter () {};
            private:
                Sample_Cancel_Request_DataWriter (const Sample_Cancel_Request_DataWriter &);
                Sample_Cancel_Request_DataWriter & operator = (const Sample_Cancel_Request_DataWriter &);
            };

            class  Sample_Cancel_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Cancel_Request_DataReader_ptr _ptr_type;
                typedef Sample_Cancel_Request_DataReader_var _var_type;

                static Sample_Cancel_Request_DataReader_ptr _duplicate (Sample_Cancel_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Cancel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Cancel_Request_& instance) = 0;

            protected:
                Sample_Cancel_Request_DataReader () {};
                ~Sample_Cancel_Request_DataReader () {};
            private:
                Sample_Cancel_Request_DataReader (const Sample_Cancel_Request_DataReader &);
                Sample_Cancel_Request_DataReader & operator = (const Sample_Cancel_Request_DataReader &);
            };

            class  Sample_Cancel_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Cancel_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Cancel_Request_DataReaderView_var _var_type;

                static Sample_Cancel_Request_DataReaderView_ptr _duplicate (Sample_Cancel_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Cancel_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Cancel_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Cancel_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Cancel_Request_& instance) = 0;

            protected:
                Sample_Cancel_Request_DataReaderView () {};
                ~Sample_Cancel_Request_DataReaderView () {};
            private:
                Sample_Cancel_Request_DataReaderView (const Sample_Cancel_Request_DataReaderView &);
                Sample_Cancel_Request_DataReaderView & operator = (const Sample_Cancel_Request_DataReaderView &);
            };
            class Sample_Cancel_Response_TypeSupportInterface;

            typedef Sample_Cancel_Response_TypeSupportInterface * Sample_Cancel_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Response_TypeSupportInterface> Sample_Cancel_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Response_TypeSupportInterface> Sample_Cancel_Response_TypeSupportInterface_out;


            class Sample_Cancel_Response_DataWriter;

            typedef Sample_Cancel_Response_DataWriter * Sample_Cancel_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Response_DataWriter> Sample_Cancel_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Response_DataWriter> Sample_Cancel_Response_DataWriter_out;


            class Sample_Cancel_Response_DataReader;

            typedef Sample_Cancel_Response_DataReader * Sample_Cancel_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Response_DataReader> Sample_Cancel_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Response_DataReader> Sample_Cancel_Response_DataReader_out;


            class Sample_Cancel_Response_DataReaderView;

            typedef Sample_Cancel_Response_DataReaderView * Sample_Cancel_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Cancel_Response_DataReaderView> Sample_Cancel_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Cancel_Response_DataReaderView> Sample_Cancel_Response_DataReaderView_out;

            struct Sample_Cancel_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_Cancel_Response_, struct Sample_Cancel_Response_Seq_uniq_> Sample_Cancel_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Cancel_Response_Seq> Sample_Cancel_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Cancel_Response_Seq> Sample_Cancel_Response_Seq_out;

            class  Sample_Cancel_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Cancel_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Cancel_Response_TypeSupportInterface_var _var_type;

                static Sample_Cancel_Response_TypeSupportInterface_ptr _duplicate (Sample_Cancel_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Cancel_Response_TypeSupportInterface () {};
                ~Sample_Cancel_Response_TypeSupportInterface () {};
            private:
                Sample_Cancel_Response_TypeSupportInterface (const Sample_Cancel_Response_TypeSupportInterface &);
                Sample_Cancel_Response_TypeSupportInterface & operator = (const Sample_Cancel_Response_TypeSupportInterface &);
            };

            class  Sample_Cancel_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Cancel_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Cancel_Response_DataWriter_var _var_type;

                static Sample_Cancel_Response_DataWriter_ptr _duplicate (Sample_Cancel_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Cancel_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Cancel_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Cancel_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Cancel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Cancel_Response_& instance_data) = 0;

            protected:
                Sample_Cancel_Response_DataWriter () {};
                ~Sample_Cancel_Response_DataWriter () {};
            private:
                Sample_Cancel_Response_DataWriter (const Sample_Cancel_Response_DataWriter &);
                Sample_Cancel_Response_DataWriter & operator = (const Sample_Cancel_Response_DataWriter &);
            };

            class  Sample_Cancel_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Cancel_Response_DataReader_ptr _ptr_type;
                typedef Sample_Cancel_Response_DataReader_var _var_type;

                static Sample_Cancel_Response_DataReader_ptr _duplicate (Sample_Cancel_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Cancel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Cancel_Response_& instance) = 0;

            protected:
                Sample_Cancel_Response_DataReader () {};
                ~Sample_Cancel_Response_DataReader () {};
            private:
                Sample_Cancel_Response_DataReader (const Sample_Cancel_Response_DataReader &);
                Sample_Cancel_Response_DataReader & operator = (const Sample_Cancel_Response_DataReader &);
            };

            class  Sample_Cancel_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Cancel_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Cancel_Response_DataReaderView_var _var_type;

                static Sample_Cancel_Response_DataReaderView_ptr _duplicate (Sample_Cancel_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Cancel_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Cancel_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Cancel_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Cancel_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Cancel_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Cancel_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Cancel_Response_& instance) = 0;

            protected:
                Sample_Cancel_Response_DataReaderView () {};
                ~Sample_Cancel_Response_DataReaderView () {};
            private:
                Sample_Cancel_Response_DataReaderView (const Sample_Cancel_Response_DataReaderView &);
                Sample_Cancel_Response_DataReaderView & operator = (const Sample_Cancel_Response_DataReaderView &);
            };
        }

    }

}

#endif
