#ifndef _H_5BB67162F7062C39D29E88AF9AD2D10E_RemoveTags__H_
#define _H_5BB67162F7062C39D29E88AF9AD2D10E_RemoveTags__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  RemoveTags_Request_
            {
                struct _keys__seq_uniq_{};
                typedef DDS_DCPSUStrSeqT< struct _keys__seq_uniq_ > _keys__seq;
                typedef DDS_DCPSUStrSeq_var< _keys__seq > _keys__seq_var;
                typedef DDS_DCPSUStrSeq_out< _keys__seq > _keys__seq_out;
                _keys__seq keys_;
            };

            typedef DDS_DCPSStruct_var<RemoveTags_Request_> RemoveTags_Request__var;
            typedef DDS_DCPSStruct_out < RemoveTags_Request_> RemoveTags_Request__out;

            struct  RemoveTags_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<RemoveTags_Response_> RemoveTags_Response__var;
            typedef DDS_DCPSStruct_out < RemoveTags_Response_> RemoveTags_Response__out;

            struct  Sample_RemoveTags_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::RemoveTags_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveTags_Request_> Sample_RemoveTags_Request__var;
            typedef DDS_DCPSStruct_out < Sample_RemoveTags_Request_> Sample_RemoveTags_Request__out;

            struct  Sample_RemoveTags_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::RemoveTags_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_RemoveTags_Response_> Sample_RemoveTags_Response__var;
            typedef DDS_DCPSStruct_out < Sample_RemoveTags_Response_> Sample_RemoveTags_Response__out;

        }

    }

}

#endif /* _H_5BB67162F7062C39D29E88AF9AD2D10E_RemoveTags__H_ */
