#ifndef _H_5BB67162F7062C39D29E88AF9AD2D10E_RemoveTags_DCPS_H_
#define _H_5BB67162F7062C39D29E88AF9AD2D10E_RemoveTags_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RemoveTags_.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class RemoveTags_Request_TypeSupportInterface;

            typedef RemoveTags_Request_TypeSupportInterface * RemoveTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Request_TypeSupportInterface> RemoveTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Request_TypeSupportInterface> RemoveTags_Request_TypeSupportInterface_out;


            class RemoveTags_Request_DataWriter;

            typedef RemoveTags_Request_DataWriter * RemoveTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Request_DataWriter> RemoveTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Request_DataWriter> RemoveTags_Request_DataWriter_out;


            class RemoveTags_Request_DataReader;

            typedef RemoveTags_Request_DataReader * RemoveTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Request_DataReader> RemoveTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Request_DataReader> RemoveTags_Request_DataReader_out;


            class RemoveTags_Request_DataReaderView;

            typedef RemoveTags_Request_DataReaderView * RemoveTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Request_DataReaderView> RemoveTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Request_DataReaderView> RemoveTags_Request_DataReaderView_out;

            struct RemoveTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RemoveTags_Request_, struct RemoveTags_Request_Seq_uniq_> RemoveTags_Request_Seq;
            typedef DDS_DCPSSequence_var < RemoveTags_Request_Seq> RemoveTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < RemoveTags_Request_Seq> RemoveTags_Request_Seq_out;

            class  RemoveTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RemoveTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef RemoveTags_Request_TypeSupportInterface_var _var_type;

                static RemoveTags_Request_TypeSupportInterface_ptr _duplicate (RemoveTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RemoveTags_Request_TypeSupportInterface () {};
                ~RemoveTags_Request_TypeSupportInterface () {};
            private:
                RemoveTags_Request_TypeSupportInterface (const RemoveTags_Request_TypeSupportInterface &);
                RemoveTags_Request_TypeSupportInterface & operator = (const RemoveTags_Request_TypeSupportInterface &);
            };

            class  RemoveTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RemoveTags_Request_DataWriter_ptr _ptr_type;
                typedef RemoveTags_Request_DataWriter_var _var_type;

                static RemoveTags_Request_DataWriter_ptr _duplicate (RemoveTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RemoveTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RemoveTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RemoveTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveTags_Request_& instance_data) = 0;

            protected:
                RemoveTags_Request_DataWriter () {};
                ~RemoveTags_Request_DataWriter () {};
            private:
                RemoveTags_Request_DataWriter (const RemoveTags_Request_DataWriter &);
                RemoveTags_Request_DataWriter & operator = (const RemoveTags_Request_DataWriter &);
            };

            class  RemoveTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RemoveTags_Request_DataReader_ptr _ptr_type;
                typedef RemoveTags_Request_DataReader_var _var_type;

                static RemoveTags_Request_DataReader_ptr _duplicate (RemoveTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveTags_Request_& instance) = 0;

            protected:
                RemoveTags_Request_DataReader () {};
                ~RemoveTags_Request_DataReader () {};
            private:
                RemoveTags_Request_DataReader (const RemoveTags_Request_DataReader &);
                RemoveTags_Request_DataReader & operator = (const RemoveTags_Request_DataReader &);
            };

            class  RemoveTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RemoveTags_Request_DataReaderView_ptr _ptr_type;
                typedef RemoveTags_Request_DataReaderView_var _var_type;

                static RemoveTags_Request_DataReaderView_ptr _duplicate (RemoveTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveTags_Request_& instance) = 0;

            protected:
                RemoveTags_Request_DataReaderView () {};
                ~RemoveTags_Request_DataReaderView () {};
            private:
                RemoveTags_Request_DataReaderView (const RemoveTags_Request_DataReaderView &);
                RemoveTags_Request_DataReaderView & operator = (const RemoveTags_Request_DataReaderView &);
            };
            class RemoveTags_Response_TypeSupportInterface;

            typedef RemoveTags_Response_TypeSupportInterface * RemoveTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Response_TypeSupportInterface> RemoveTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Response_TypeSupportInterface> RemoveTags_Response_TypeSupportInterface_out;


            class RemoveTags_Response_DataWriter;

            typedef RemoveTags_Response_DataWriter * RemoveTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Response_DataWriter> RemoveTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Response_DataWriter> RemoveTags_Response_DataWriter_out;


            class RemoveTags_Response_DataReader;

            typedef RemoveTags_Response_DataReader * RemoveTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Response_DataReader> RemoveTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Response_DataReader> RemoveTags_Response_DataReader_out;


            class RemoveTags_Response_DataReaderView;

            typedef RemoveTags_Response_DataReaderView * RemoveTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RemoveTags_Response_DataReaderView> RemoveTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RemoveTags_Response_DataReaderView> RemoveTags_Response_DataReaderView_out;

            struct RemoveTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RemoveTags_Response_, struct RemoveTags_Response_Seq_uniq_> RemoveTags_Response_Seq;
            typedef DDS_DCPSSequence_var < RemoveTags_Response_Seq> RemoveTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < RemoveTags_Response_Seq> RemoveTags_Response_Seq_out;

            class  RemoveTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RemoveTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef RemoveTags_Response_TypeSupportInterface_var _var_type;

                static RemoveTags_Response_TypeSupportInterface_ptr _duplicate (RemoveTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RemoveTags_Response_TypeSupportInterface () {};
                ~RemoveTags_Response_TypeSupportInterface () {};
            private:
                RemoveTags_Response_TypeSupportInterface (const RemoveTags_Response_TypeSupportInterface &);
                RemoveTags_Response_TypeSupportInterface & operator = (const RemoveTags_Response_TypeSupportInterface &);
            };

            class  RemoveTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RemoveTags_Response_DataWriter_ptr _ptr_type;
                typedef RemoveTags_Response_DataWriter_var _var_type;

                static RemoveTags_Response_DataWriter_ptr _duplicate (RemoveTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RemoveTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RemoveTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RemoveTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveTags_Response_& instance_data) = 0;

            protected:
                RemoveTags_Response_DataWriter () {};
                ~RemoveTags_Response_DataWriter () {};
            private:
                RemoveTags_Response_DataWriter (const RemoveTags_Response_DataWriter &);
                RemoveTags_Response_DataWriter & operator = (const RemoveTags_Response_DataWriter &);
            };

            class  RemoveTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RemoveTags_Response_DataReader_ptr _ptr_type;
                typedef RemoveTags_Response_DataReader_var _var_type;

                static RemoveTags_Response_DataReader_ptr _duplicate (RemoveTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveTags_Response_& instance) = 0;

            protected:
                RemoveTags_Response_DataReader () {};
                ~RemoveTags_Response_DataReader () {};
            private:
                RemoveTags_Response_DataReader (const RemoveTags_Response_DataReader &);
                RemoveTags_Response_DataReader & operator = (const RemoveTags_Response_DataReader &);
            };

            class  RemoveTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RemoveTags_Response_DataReaderView_ptr _ptr_type;
                typedef RemoveTags_Response_DataReaderView_var _var_type;

                static RemoveTags_Response_DataReaderView_ptr _duplicate (RemoveTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RemoveTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RemoveTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RemoveTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RemoveTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RemoveTags_Response_& instance) = 0;

            protected:
                RemoveTags_Response_DataReaderView () {};
                ~RemoveTags_Response_DataReaderView () {};
            private:
                RemoveTags_Response_DataReaderView (const RemoveTags_Response_DataReaderView &);
                RemoveTags_Response_DataReaderView & operator = (const RemoveTags_Response_DataReaderView &);
            };
            class Sample_RemoveTags_Request_TypeSupportInterface;

            typedef Sample_RemoveTags_Request_TypeSupportInterface * Sample_RemoveTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Request_TypeSupportInterface> Sample_RemoveTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Request_TypeSupportInterface> Sample_RemoveTags_Request_TypeSupportInterface_out;


            class Sample_RemoveTags_Request_DataWriter;

            typedef Sample_RemoveTags_Request_DataWriter * Sample_RemoveTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Request_DataWriter> Sample_RemoveTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Request_DataWriter> Sample_RemoveTags_Request_DataWriter_out;


            class Sample_RemoveTags_Request_DataReader;

            typedef Sample_RemoveTags_Request_DataReader * Sample_RemoveTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Request_DataReader> Sample_RemoveTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Request_DataReader> Sample_RemoveTags_Request_DataReader_out;


            class Sample_RemoveTags_Request_DataReaderView;

            typedef Sample_RemoveTags_Request_DataReaderView * Sample_RemoveTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Request_DataReaderView> Sample_RemoveTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Request_DataReaderView> Sample_RemoveTags_Request_DataReaderView_out;

            struct Sample_RemoveTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_RemoveTags_Request_, struct Sample_RemoveTags_Request_Seq_uniq_> Sample_RemoveTags_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_RemoveTags_Request_Seq> Sample_RemoveTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_RemoveTags_Request_Seq> Sample_RemoveTags_Request_Seq_out;

            class  Sample_RemoveTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_RemoveTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_RemoveTags_Request_TypeSupportInterface_var _var_type;

                static Sample_RemoveTags_Request_TypeSupportInterface_ptr _duplicate (Sample_RemoveTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_RemoveTags_Request_TypeSupportInterface () {};
                ~Sample_RemoveTags_Request_TypeSupportInterface () {};
            private:
                Sample_RemoveTags_Request_TypeSupportInterface (const Sample_RemoveTags_Request_TypeSupportInterface &);
                Sample_RemoveTags_Request_TypeSupportInterface & operator = (const Sample_RemoveTags_Request_TypeSupportInterface &);
            };

            class  Sample_RemoveTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_RemoveTags_Request_DataWriter_ptr _ptr_type;
                typedef Sample_RemoveTags_Request_DataWriter_var _var_type;

                static Sample_RemoveTags_Request_DataWriter_ptr _duplicate (Sample_RemoveTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_RemoveTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_RemoveTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_RemoveTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveTags_Request_& instance_data) = 0;

            protected:
                Sample_RemoveTags_Request_DataWriter () {};
                ~Sample_RemoveTags_Request_DataWriter () {};
            private:
                Sample_RemoveTags_Request_DataWriter (const Sample_RemoveTags_Request_DataWriter &);
                Sample_RemoveTags_Request_DataWriter & operator = (const Sample_RemoveTags_Request_DataWriter &);
            };

            class  Sample_RemoveTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_RemoveTags_Request_DataReader_ptr _ptr_type;
                typedef Sample_RemoveTags_Request_DataReader_var _var_type;

                static Sample_RemoveTags_Request_DataReader_ptr _duplicate (Sample_RemoveTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveTags_Request_& instance) = 0;

            protected:
                Sample_RemoveTags_Request_DataReader () {};
                ~Sample_RemoveTags_Request_DataReader () {};
            private:
                Sample_RemoveTags_Request_DataReader (const Sample_RemoveTags_Request_DataReader &);
                Sample_RemoveTags_Request_DataReader & operator = (const Sample_RemoveTags_Request_DataReader &);
            };

            class  Sample_RemoveTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_RemoveTags_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_RemoveTags_Request_DataReaderView_var _var_type;

                static Sample_RemoveTags_Request_DataReaderView_ptr _duplicate (Sample_RemoveTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveTags_Request_& instance) = 0;

            protected:
                Sample_RemoveTags_Request_DataReaderView () {};
                ~Sample_RemoveTags_Request_DataReaderView () {};
            private:
                Sample_RemoveTags_Request_DataReaderView (const Sample_RemoveTags_Request_DataReaderView &);
                Sample_RemoveTags_Request_DataReaderView & operator = (const Sample_RemoveTags_Request_DataReaderView &);
            };
            class Sample_RemoveTags_Response_TypeSupportInterface;

            typedef Sample_RemoveTags_Response_TypeSupportInterface * Sample_RemoveTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Response_TypeSupportInterface> Sample_RemoveTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Response_TypeSupportInterface> Sample_RemoveTags_Response_TypeSupportInterface_out;


            class Sample_RemoveTags_Response_DataWriter;

            typedef Sample_RemoveTags_Response_DataWriter * Sample_RemoveTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Response_DataWriter> Sample_RemoveTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Response_DataWriter> Sample_RemoveTags_Response_DataWriter_out;


            class Sample_RemoveTags_Response_DataReader;

            typedef Sample_RemoveTags_Response_DataReader * Sample_RemoveTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Response_DataReader> Sample_RemoveTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Response_DataReader> Sample_RemoveTags_Response_DataReader_out;


            class Sample_RemoveTags_Response_DataReaderView;

            typedef Sample_RemoveTags_Response_DataReaderView * Sample_RemoveTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_RemoveTags_Response_DataReaderView> Sample_RemoveTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_RemoveTags_Response_DataReaderView> Sample_RemoveTags_Response_DataReaderView_out;

            struct Sample_RemoveTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_RemoveTags_Response_, struct Sample_RemoveTags_Response_Seq_uniq_> Sample_RemoveTags_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_RemoveTags_Response_Seq> Sample_RemoveTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_RemoveTags_Response_Seq> Sample_RemoveTags_Response_Seq_out;

            class  Sample_RemoveTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_RemoveTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_RemoveTags_Response_TypeSupportInterface_var _var_type;

                static Sample_RemoveTags_Response_TypeSupportInterface_ptr _duplicate (Sample_RemoveTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_RemoveTags_Response_TypeSupportInterface () {};
                ~Sample_RemoveTags_Response_TypeSupportInterface () {};
            private:
                Sample_RemoveTags_Response_TypeSupportInterface (const Sample_RemoveTags_Response_TypeSupportInterface &);
                Sample_RemoveTags_Response_TypeSupportInterface & operator = (const Sample_RemoveTags_Response_TypeSupportInterface &);
            };

            class  Sample_RemoveTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_RemoveTags_Response_DataWriter_ptr _ptr_type;
                typedef Sample_RemoveTags_Response_DataWriter_var _var_type;

                static Sample_RemoveTags_Response_DataWriter_ptr _duplicate (Sample_RemoveTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_RemoveTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_RemoveTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_RemoveTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveTags_Response_& instance_data) = 0;

            protected:
                Sample_RemoveTags_Response_DataWriter () {};
                ~Sample_RemoveTags_Response_DataWriter () {};
            private:
                Sample_RemoveTags_Response_DataWriter (const Sample_RemoveTags_Response_DataWriter &);
                Sample_RemoveTags_Response_DataWriter & operator = (const Sample_RemoveTags_Response_DataWriter &);
            };

            class  Sample_RemoveTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_RemoveTags_Response_DataReader_ptr _ptr_type;
                typedef Sample_RemoveTags_Response_DataReader_var _var_type;

                static Sample_RemoveTags_Response_DataReader_ptr _duplicate (Sample_RemoveTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveTags_Response_& instance) = 0;

            protected:
                Sample_RemoveTags_Response_DataReader () {};
                ~Sample_RemoveTags_Response_DataReader () {};
            private:
                Sample_RemoveTags_Response_DataReader (const Sample_RemoveTags_Response_DataReader &);
                Sample_RemoveTags_Response_DataReader & operator = (const Sample_RemoveTags_Response_DataReader &);
            };

            class  Sample_RemoveTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_RemoveTags_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_RemoveTags_Response_DataReaderView_var _var_type;

                static Sample_RemoveTags_Response_DataReaderView_ptr _duplicate (Sample_RemoveTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_RemoveTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_RemoveTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_RemoveTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_RemoveTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_RemoveTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_RemoveTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_RemoveTags_Response_& instance) = 0;

            protected:
                Sample_RemoveTags_Response_DataReaderView () {};
                ~Sample_RemoveTags_Response_DataReaderView () {};
            private:
                Sample_RemoveTags_Response_DataReaderView (const Sample_RemoveTags_Response_DataReaderView &);
                Sample_RemoveTags_Response_DataReaderView & operator = (const Sample_RemoveTags_Response_DataReaderView &);
            };
        }

    }

}

#endif
