// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from robomaker_simulation_msgs:msg/Tag.idl
// generated code does not contain a copyright notice

#ifndef ROBOMAKER_SIMULATION_MSGS__MSG__TAG__FUNCTIONS_H_
#define ROBOMAKER_SIMULATION_MSGS__MSG__TAG__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "robomaker_simulation_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "robomaker_simulation_msgs/msg/tag__struct.h"

/// Initialize msg/Tag message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * robomaker_simulation_msgs__msg__Tag
 * )) before or use
 * robomaker_simulation_msgs__msg__Tag__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
bool
robomaker_simulation_msgs__msg__Tag__init(robomaker_simulation_msgs__msg__Tag * msg);

/// Finalize msg/Tag message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__msg__Tag__fini(robomaker_simulation_msgs__msg__Tag * msg);

/// Create msg/Tag message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * robomaker_simulation_msgs__msg__Tag__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
robomaker_simulation_msgs__msg__Tag *
robomaker_simulation_msgs__msg__Tag__create();

/// Destroy msg/Tag message.
/**
 * It calls
 * robomaker_simulation_msgs__msg__Tag__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__msg__Tag__destroy(robomaker_simulation_msgs__msg__Tag * msg);


/// Initialize array of msg/Tag messages.
/**
 * It allocates the memory for the number of elements and calls
 * robomaker_simulation_msgs__msg__Tag__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
bool
robomaker_simulation_msgs__msg__Tag__Sequence__init(robomaker_simulation_msgs__msg__Tag__Sequence * array, size_t size);

/// Finalize array of msg/Tag messages.
/**
 * It calls
 * robomaker_simulation_msgs__msg__Tag__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__msg__Tag__Sequence__fini(robomaker_simulation_msgs__msg__Tag__Sequence * array);

/// Create array of msg/Tag messages.
/**
 * It allocates the memory for the array and calls
 * robomaker_simulation_msgs__msg__Tag__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
robomaker_simulation_msgs__msg__Tag__Sequence *
robomaker_simulation_msgs__msg__Tag__Sequence__create(size_t size);

/// Destroy array of msg/Tag messages.
/**
 * It calls
 * robomaker_simulation_msgs__msg__Tag__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__msg__Tag__Sequence__destroy(robomaker_simulation_msgs__msg__Tag__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ROBOMAKER_SIMULATION_MSGS__MSG__TAG__FUNCTIONS_H_
