// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from robomaker_simulation_msgs:srv/AddTags.idl
// generated code does not contain a copyright notice

#ifndef ROBOMAKER_SIMULATION_MSGS__SRV__ADD_TAGS__FUNCTIONS_H_
#define ROBOMAKER_SIMULATION_MSGS__SRV__ADD_TAGS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "robomaker_simulation_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "robomaker_simulation_msgs/srv/add_tags__struct.h"

/// Initialize srv/AddTags message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * robomaker_simulation_msgs__srv__AddTags_Request
 * )) before or use
 * robomaker_simulation_msgs__srv__AddTags_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
bool
robomaker_simulation_msgs__srv__AddTags_Request__init(robomaker_simulation_msgs__srv__AddTags_Request * msg);

/// Finalize srv/AddTags message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Request__fini(robomaker_simulation_msgs__srv__AddTags_Request * msg);

/// Create srv/AddTags message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * robomaker_simulation_msgs__srv__AddTags_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
robomaker_simulation_msgs__srv__AddTags_Request *
robomaker_simulation_msgs__srv__AddTags_Request__create();

/// Destroy srv/AddTags message.
/**
 * It calls
 * robomaker_simulation_msgs__srv__AddTags_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Request__destroy(robomaker_simulation_msgs__srv__AddTags_Request * msg);


/// Initialize array of srv/AddTags messages.
/**
 * It allocates the memory for the number of elements and calls
 * robomaker_simulation_msgs__srv__AddTags_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
bool
robomaker_simulation_msgs__srv__AddTags_Request__Sequence__init(robomaker_simulation_msgs__srv__AddTags_Request__Sequence * array, size_t size);

/// Finalize array of srv/AddTags messages.
/**
 * It calls
 * robomaker_simulation_msgs__srv__AddTags_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Request__Sequence__fini(robomaker_simulation_msgs__srv__AddTags_Request__Sequence * array);

/// Create array of srv/AddTags messages.
/**
 * It allocates the memory for the array and calls
 * robomaker_simulation_msgs__srv__AddTags_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
robomaker_simulation_msgs__srv__AddTags_Request__Sequence *
robomaker_simulation_msgs__srv__AddTags_Request__Sequence__create(size_t size);

/// Destroy array of srv/AddTags messages.
/**
 * It calls
 * robomaker_simulation_msgs__srv__AddTags_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Request__Sequence__destroy(robomaker_simulation_msgs__srv__AddTags_Request__Sequence * array);

/// Initialize srv/AddTags message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * robomaker_simulation_msgs__srv__AddTags_Response
 * )) before or use
 * robomaker_simulation_msgs__srv__AddTags_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
bool
robomaker_simulation_msgs__srv__AddTags_Response__init(robomaker_simulation_msgs__srv__AddTags_Response * msg);

/// Finalize srv/AddTags message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Response__fini(robomaker_simulation_msgs__srv__AddTags_Response * msg);

/// Create srv/AddTags message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * robomaker_simulation_msgs__srv__AddTags_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
robomaker_simulation_msgs__srv__AddTags_Response *
robomaker_simulation_msgs__srv__AddTags_Response__create();

/// Destroy srv/AddTags message.
/**
 * It calls
 * robomaker_simulation_msgs__srv__AddTags_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Response__destroy(robomaker_simulation_msgs__srv__AddTags_Response * msg);


/// Initialize array of srv/AddTags messages.
/**
 * It allocates the memory for the number of elements and calls
 * robomaker_simulation_msgs__srv__AddTags_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
bool
robomaker_simulation_msgs__srv__AddTags_Response__Sequence__init(robomaker_simulation_msgs__srv__AddTags_Response__Sequence * array, size_t size);

/// Finalize array of srv/AddTags messages.
/**
 * It calls
 * robomaker_simulation_msgs__srv__AddTags_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Response__Sequence__fini(robomaker_simulation_msgs__srv__AddTags_Response__Sequence * array);

/// Create array of srv/AddTags messages.
/**
 * It allocates the memory for the array and calls
 * robomaker_simulation_msgs__srv__AddTags_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
robomaker_simulation_msgs__srv__AddTags_Response__Sequence *
robomaker_simulation_msgs__srv__AddTags_Response__Sequence__create(size_t size);

/// Destroy array of srv/AddTags messages.
/**
 * It calls
 * robomaker_simulation_msgs__srv__AddTags_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_robomaker_simulation_msgs
void
robomaker_simulation_msgs__srv__AddTags_Response__Sequence__destroy(robomaker_simulation_msgs__srv__AddTags_Response__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // ROBOMAKER_SIMULATION_MSGS__SRV__ADD_TAGS__FUNCTIONS_H_
