#ifndef _H_258E781FEA53DC6D18CE1B6CC46E14AE_Cancel__H_
#define _H_258E781FEA53DC6D18CE1B6CC46E14AE_Cancel__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  Cancel_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<Cancel_Request_> Cancel_Request__var;
            typedef Cancel_Request_& Cancel_Request__out;

            struct  Cancel_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<Cancel_Response_> Cancel_Response__var;
            typedef DDS_DCPSStruct_out < Cancel_Response_> Cancel_Response__out;

            struct  Sample_Cancel_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::Cancel_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Cancel_Request_> Sample_Cancel_Request__var;
            typedef Sample_Cancel_Request_& Sample_Cancel_Request__out;

            struct  Sample_Cancel_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::Cancel_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Cancel_Response_> Sample_Cancel_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Cancel_Response_> Sample_Cancel_Response__out;

        }

    }

}

#endif /* _H_258E781FEA53DC6D18CE1B6CC46E14AE_Cancel__H_ */
