#ifndef _H_1ADBB0B2E8BE1F9FA748FE3E51A7E620_ListTags__H_
#define _H_1ADBB0B2E8BE1F9FA748FE3E51A7E620_ListTags__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "robomaker_simulation_msgs/msg/dds_opensplice/Tag_.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  ListTags_Request_
            {
                ::DDS::Octet structure_needs_at_least_one_member_;
            };

            typedef DDS_DCPSStruct_var<ListTags_Request_> ListTags_Request__var;
            typedef ListTags_Request_& ListTags_Request__out;

            struct  ListTags_Response_
            {
                struct _tags__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::robomaker_simulation_msgs::msg::dds_::Tag_, struct _tags__seq_uniq_ > _tags__seq;
                typedef DDS_DCPSSequence_var< _tags__seq > _tags__seq_var;
                typedef DDS_DCPSSequence_out< _tags__seq > _tags__seq_out;
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
                _tags__seq tags_;
            };

            typedef DDS_DCPSStruct_var<ListTags_Response_> ListTags_Response__var;
            typedef DDS_DCPSStruct_out < ListTags_Response_> ListTags_Response__out;

            struct  Sample_ListTags_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::ListTags_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_ListTags_Request_> Sample_ListTags_Request__var;
            typedef Sample_ListTags_Request_& Sample_ListTags_Request__out;

            struct  Sample_ListTags_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::robomaker_simulation_msgs::srv::dds_::ListTags_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_ListTags_Response_> Sample_ListTags_Response__var;
            typedef DDS_DCPSStruct_out < Sample_ListTags_Response_> Sample_ListTags_Response__out;

        }

    }

}

#endif /* _H_1ADBB0B2E8BE1F9FA748FE3E51A7E620_ListTags__H_ */
