#ifndef _H_1ADBB0B2E8BE1F9FA748FE3E51A7E620_ListTags_DCPS_H_
#define _H_1ADBB0B2E8BE1F9FA748FE3E51A7E620_ListTags_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ListTags_.h"


namespace robomaker_simulation_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class ListTags_Request_TypeSupportInterface;

            typedef ListTags_Request_TypeSupportInterface * ListTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Request_TypeSupportInterface> ListTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ListTags_Request_TypeSupportInterface> ListTags_Request_TypeSupportInterface_out;


            class ListTags_Request_DataWriter;

            typedef ListTags_Request_DataWriter * ListTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Request_DataWriter> ListTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < ListTags_Request_DataWriter> ListTags_Request_DataWriter_out;


            class ListTags_Request_DataReader;

            typedef ListTags_Request_DataReader * ListTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Request_DataReader> ListTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < ListTags_Request_DataReader> ListTags_Request_DataReader_out;


            class ListTags_Request_DataReaderView;

            typedef ListTags_Request_DataReaderView * ListTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Request_DataReaderView> ListTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ListTags_Request_DataReaderView> ListTags_Request_DataReaderView_out;

            struct ListTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ListTags_Request_, struct ListTags_Request_Seq_uniq_> ListTags_Request_Seq;
            typedef DDS_DCPSSequence_var < ListTags_Request_Seq> ListTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < ListTags_Request_Seq> ListTags_Request_Seq_out;

            class  ListTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ListTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef ListTags_Request_TypeSupportInterface_var _var_type;

                static ListTags_Request_TypeSupportInterface_ptr _duplicate (ListTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ListTags_Request_TypeSupportInterface () {};
                ~ListTags_Request_TypeSupportInterface () {};
            private:
                ListTags_Request_TypeSupportInterface (const ListTags_Request_TypeSupportInterface &);
                ListTags_Request_TypeSupportInterface & operator = (const ListTags_Request_TypeSupportInterface &);
            };

            class  ListTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ListTags_Request_DataWriter_ptr _ptr_type;
                typedef ListTags_Request_DataWriter_var _var_type;

                static ListTags_Request_DataWriter_ptr _duplicate (ListTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ListTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ListTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ListTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ListTags_Request_& instance_data) = 0;

            protected:
                ListTags_Request_DataWriter () {};
                ~ListTags_Request_DataWriter () {};
            private:
                ListTags_Request_DataWriter (const ListTags_Request_DataWriter &);
                ListTags_Request_DataWriter & operator = (const ListTags_Request_DataWriter &);
            };

            class  ListTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ListTags_Request_DataReader_ptr _ptr_type;
                typedef ListTags_Request_DataReader_var _var_type;

                static ListTags_Request_DataReader_ptr _duplicate (ListTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ListTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ListTags_Request_& instance) = 0;

            protected:
                ListTags_Request_DataReader () {};
                ~ListTags_Request_DataReader () {};
            private:
                ListTags_Request_DataReader (const ListTags_Request_DataReader &);
                ListTags_Request_DataReader & operator = (const ListTags_Request_DataReader &);
            };

            class  ListTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ListTags_Request_DataReaderView_ptr _ptr_type;
                typedef ListTags_Request_DataReaderView_var _var_type;

                static ListTags_Request_DataReaderView_ptr _duplicate (ListTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ListTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ListTags_Request_& instance) = 0;

            protected:
                ListTags_Request_DataReaderView () {};
                ~ListTags_Request_DataReaderView () {};
            private:
                ListTags_Request_DataReaderView (const ListTags_Request_DataReaderView &);
                ListTags_Request_DataReaderView & operator = (const ListTags_Request_DataReaderView &);
            };
            class ListTags_Response_TypeSupportInterface;

            typedef ListTags_Response_TypeSupportInterface * ListTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Response_TypeSupportInterface> ListTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ListTags_Response_TypeSupportInterface> ListTags_Response_TypeSupportInterface_out;


            class ListTags_Response_DataWriter;

            typedef ListTags_Response_DataWriter * ListTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Response_DataWriter> ListTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < ListTags_Response_DataWriter> ListTags_Response_DataWriter_out;


            class ListTags_Response_DataReader;

            typedef ListTags_Response_DataReader * ListTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Response_DataReader> ListTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < ListTags_Response_DataReader> ListTags_Response_DataReader_out;


            class ListTags_Response_DataReaderView;

            typedef ListTags_Response_DataReaderView * ListTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ListTags_Response_DataReaderView> ListTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ListTags_Response_DataReaderView> ListTags_Response_DataReaderView_out;

            struct ListTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ListTags_Response_, struct ListTags_Response_Seq_uniq_> ListTags_Response_Seq;
            typedef DDS_DCPSSequence_var < ListTags_Response_Seq> ListTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < ListTags_Response_Seq> ListTags_Response_Seq_out;

            class  ListTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ListTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef ListTags_Response_TypeSupportInterface_var _var_type;

                static ListTags_Response_TypeSupportInterface_ptr _duplicate (ListTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ListTags_Response_TypeSupportInterface () {};
                ~ListTags_Response_TypeSupportInterface () {};
            private:
                ListTags_Response_TypeSupportInterface (const ListTags_Response_TypeSupportInterface &);
                ListTags_Response_TypeSupportInterface & operator = (const ListTags_Response_TypeSupportInterface &);
            };

            class  ListTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ListTags_Response_DataWriter_ptr _ptr_type;
                typedef ListTags_Response_DataWriter_var _var_type;

                static ListTags_Response_DataWriter_ptr _duplicate (ListTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ListTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ListTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ListTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ListTags_Response_& instance_data) = 0;

            protected:
                ListTags_Response_DataWriter () {};
                ~ListTags_Response_DataWriter () {};
            private:
                ListTags_Response_DataWriter (const ListTags_Response_DataWriter &);
                ListTags_Response_DataWriter & operator = (const ListTags_Response_DataWriter &);
            };

            class  ListTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ListTags_Response_DataReader_ptr _ptr_type;
                typedef ListTags_Response_DataReader_var _var_type;

                static ListTags_Response_DataReader_ptr _duplicate (ListTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ListTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ListTags_Response_& instance) = 0;

            protected:
                ListTags_Response_DataReader () {};
                ~ListTags_Response_DataReader () {};
            private:
                ListTags_Response_DataReader (const ListTags_Response_DataReader &);
                ListTags_Response_DataReader & operator = (const ListTags_Response_DataReader &);
            };

            class  ListTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ListTags_Response_DataReaderView_ptr _ptr_type;
                typedef ListTags_Response_DataReaderView_var _var_type;

                static ListTags_Response_DataReaderView_ptr _duplicate (ListTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ListTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ListTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ListTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ListTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ListTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ListTags_Response_& instance) = 0;

            protected:
                ListTags_Response_DataReaderView () {};
                ~ListTags_Response_DataReaderView () {};
            private:
                ListTags_Response_DataReaderView (const ListTags_Response_DataReaderView &);
                ListTags_Response_DataReaderView & operator = (const ListTags_Response_DataReaderView &);
            };
            class Sample_ListTags_Request_TypeSupportInterface;

            typedef Sample_ListTags_Request_TypeSupportInterface * Sample_ListTags_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Request_TypeSupportInterface> Sample_ListTags_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Request_TypeSupportInterface> Sample_ListTags_Request_TypeSupportInterface_out;


            class Sample_ListTags_Request_DataWriter;

            typedef Sample_ListTags_Request_DataWriter * Sample_ListTags_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Request_DataWriter> Sample_ListTags_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Request_DataWriter> Sample_ListTags_Request_DataWriter_out;


            class Sample_ListTags_Request_DataReader;

            typedef Sample_ListTags_Request_DataReader * Sample_ListTags_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Request_DataReader> Sample_ListTags_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Request_DataReader> Sample_ListTags_Request_DataReader_out;


            class Sample_ListTags_Request_DataReaderView;

            typedef Sample_ListTags_Request_DataReaderView * Sample_ListTags_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Request_DataReaderView> Sample_ListTags_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Request_DataReaderView> Sample_ListTags_Request_DataReaderView_out;

            struct Sample_ListTags_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_ListTags_Request_, struct Sample_ListTags_Request_Seq_uniq_> Sample_ListTags_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_ListTags_Request_Seq> Sample_ListTags_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ListTags_Request_Seq> Sample_ListTags_Request_Seq_out;

            class  Sample_ListTags_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ListTags_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ListTags_Request_TypeSupportInterface_var _var_type;

                static Sample_ListTags_Request_TypeSupportInterface_ptr _duplicate (Sample_ListTags_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ListTags_Request_TypeSupportInterface () {};
                ~Sample_ListTags_Request_TypeSupportInterface () {};
            private:
                Sample_ListTags_Request_TypeSupportInterface (const Sample_ListTags_Request_TypeSupportInterface &);
                Sample_ListTags_Request_TypeSupportInterface & operator = (const Sample_ListTags_Request_TypeSupportInterface &);
            };

            class  Sample_ListTags_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ListTags_Request_DataWriter_ptr _ptr_type;
                typedef Sample_ListTags_Request_DataWriter_var _var_type;

                static Sample_ListTags_Request_DataWriter_ptr _duplicate (Sample_ListTags_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ListTags_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ListTags_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ListTags_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ListTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ListTags_Request_& instance_data) = 0;

            protected:
                Sample_ListTags_Request_DataWriter () {};
                ~Sample_ListTags_Request_DataWriter () {};
            private:
                Sample_ListTags_Request_DataWriter (const Sample_ListTags_Request_DataWriter &);
                Sample_ListTags_Request_DataWriter & operator = (const Sample_ListTags_Request_DataWriter &);
            };

            class  Sample_ListTags_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ListTags_Request_DataReader_ptr _ptr_type;
                typedef Sample_ListTags_Request_DataReader_var _var_type;

                static Sample_ListTags_Request_DataReader_ptr _duplicate (Sample_ListTags_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ListTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ListTags_Request_& instance) = 0;

            protected:
                Sample_ListTags_Request_DataReader () {};
                ~Sample_ListTags_Request_DataReader () {};
            private:
                Sample_ListTags_Request_DataReader (const Sample_ListTags_Request_DataReader &);
                Sample_ListTags_Request_DataReader & operator = (const Sample_ListTags_Request_DataReader &);
            };

            class  Sample_ListTags_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ListTags_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_ListTags_Request_DataReaderView_var _var_type;

                static Sample_ListTags_Request_DataReaderView_ptr _duplicate (Sample_ListTags_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ListTags_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ListTags_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ListTags_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ListTags_Request_& instance) = 0;

            protected:
                Sample_ListTags_Request_DataReaderView () {};
                ~Sample_ListTags_Request_DataReaderView () {};
            private:
                Sample_ListTags_Request_DataReaderView (const Sample_ListTags_Request_DataReaderView &);
                Sample_ListTags_Request_DataReaderView & operator = (const Sample_ListTags_Request_DataReaderView &);
            };
            class Sample_ListTags_Response_TypeSupportInterface;

            typedef Sample_ListTags_Response_TypeSupportInterface * Sample_ListTags_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Response_TypeSupportInterface> Sample_ListTags_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Response_TypeSupportInterface> Sample_ListTags_Response_TypeSupportInterface_out;


            class Sample_ListTags_Response_DataWriter;

            typedef Sample_ListTags_Response_DataWriter * Sample_ListTags_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Response_DataWriter> Sample_ListTags_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Response_DataWriter> Sample_ListTags_Response_DataWriter_out;


            class Sample_ListTags_Response_DataReader;

            typedef Sample_ListTags_Response_DataReader * Sample_ListTags_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Response_DataReader> Sample_ListTags_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Response_DataReader> Sample_ListTags_Response_DataReader_out;


            class Sample_ListTags_Response_DataReaderView;

            typedef Sample_ListTags_Response_DataReaderView * Sample_ListTags_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_ListTags_Response_DataReaderView> Sample_ListTags_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_ListTags_Response_DataReaderView> Sample_ListTags_Response_DataReaderView_out;

            struct Sample_ListTags_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_ListTags_Response_, struct Sample_ListTags_Response_Seq_uniq_> Sample_ListTags_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_ListTags_Response_Seq> Sample_ListTags_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_ListTags_Response_Seq> Sample_ListTags_Response_Seq_out;

            class  Sample_ListTags_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_ListTags_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_ListTags_Response_TypeSupportInterface_var _var_type;

                static Sample_ListTags_Response_TypeSupportInterface_ptr _duplicate (Sample_ListTags_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_ListTags_Response_TypeSupportInterface () {};
                ~Sample_ListTags_Response_TypeSupportInterface () {};
            private:
                Sample_ListTags_Response_TypeSupportInterface (const Sample_ListTags_Response_TypeSupportInterface &);
                Sample_ListTags_Response_TypeSupportInterface & operator = (const Sample_ListTags_Response_TypeSupportInterface &);
            };

            class  Sample_ListTags_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_ListTags_Response_DataWriter_ptr _ptr_type;
                typedef Sample_ListTags_Response_DataWriter_var _var_type;

                static Sample_ListTags_Response_DataWriter_ptr _duplicate (Sample_ListTags_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_ListTags_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_ListTags_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_ListTags_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_ListTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ListTags_Response_& instance_data) = 0;

            protected:
                Sample_ListTags_Response_DataWriter () {};
                ~Sample_ListTags_Response_DataWriter () {};
            private:
                Sample_ListTags_Response_DataWriter (const Sample_ListTags_Response_DataWriter &);
                Sample_ListTags_Response_DataWriter & operator = (const Sample_ListTags_Response_DataWriter &);
            };

            class  Sample_ListTags_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_ListTags_Response_DataReader_ptr _ptr_type;
                typedef Sample_ListTags_Response_DataReader_var _var_type;

                static Sample_ListTags_Response_DataReader_ptr _duplicate (Sample_ListTags_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ListTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ListTags_Response_& instance) = 0;

            protected:
                Sample_ListTags_Response_DataReader () {};
                ~Sample_ListTags_Response_DataReader () {};
            private:
                Sample_ListTags_Response_DataReader (const Sample_ListTags_Response_DataReader &);
                Sample_ListTags_Response_DataReader & operator = (const Sample_ListTags_Response_DataReader &);
            };

            class  Sample_ListTags_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_ListTags_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_ListTags_Response_DataReaderView_var _var_type;

                static Sample_ListTags_Response_DataReaderView_ptr _duplicate (Sample_ListTags_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_ListTags_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_ListTags_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_ListTags_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_ListTags_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_ListTags_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_ListTags_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_ListTags_Response_& instance) = 0;

            protected:
                Sample_ListTags_Response_DataReaderView () {};
                ~Sample_ListTags_Response_DataReaderView () {};
            private:
                Sample_ListTags_Response_DataReaderView (const Sample_ListTags_Response_DataReaderView &);
                Sample_ListTags_Response_DataReaderView & operator = (const Sample_ListTags_Response_DataReaderView &);
            };
        }

    }

}

#endif
